/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */


#include <stdio.h>
#include <unistd.h>
#include <memcheck.h>
#include <dlfcn.h>

char *static_var="hallihalllo";

int test() {

  char *s, *ss;
  int  i;
  static char dynamic_library_static_var[200];

  strcpy(dynamic_library_static_var, "haha");
  s=(char*)malloc(20);
  strcpy(s, static_var);

  for (i=0; i<500; i++) {
     printf("loop %d...\n", i);
     ss=(char*)MCMalloc(5+i, __FILE__, __LINE__);
     strcpy(ss, "haha");
     strcmp("haha", ss);
     strlen(ss);
     MCFree(ss, 0, __FILE__, __LINE__);
     }
  printf("loop 10 ...\n");
  for (i=0; i<10; i++) {
     ss=(char*)malloc(5+i);
     ss=(char*)realloc(ss, (99*i)+1);
     free(ss);
     }
  free(s);
  return 0;
  }


void test_dlopen() {
  void *handele, (*test)(int);
  char *err;
  int  i;
#ifdef __CYGWIN__
  char *name=".libs/libmttest.dll";
#else
  #ifdef MEMCHECKDEBUG
    char *name=".libs/libdebmttest2.so";
  #else
    char *name=".libs/libmttest2.so";
  #endif
#endif

  handele=dlopen(name, RTLD_NOW);
  if ((err=(char*)dlerror())) {
    fprintf(stderr, "dlopen in main, could not load '%s', '%s'\n", name, err);
    exit(1);
    }

  fprintf(stderr, "handele: %lx, our func: %lx\n", (ulong)handele, (ulong)test_dlopen);
  test=handele;
  test=(void*)dlsym(handele, "test_lib");
  if((err=(char*)dlerror())) {
    fprintf(stderr, "Error %s while getting symbol %s from lib\n", err, "test_lib");
    exit(1);
    }

  fprintf(stderr, "testfunc: %lx\n", (ulong)test);

  i=0;
  test(i);
  // test((int)handele);
  dlclose(handele);
  // dlclose(handele);

  fprintf(stderr, "end dlopen");
  }

// extern struct _reent *__wrap__impure_ptr;
int main(int argc, char **argv) {
  int i=0;
  char *s="hallihallo";

  printf("adfkadlffa smain argc, argv %lx, %lx\n", (ulong)&argc, (ulong)argv);
  printf("s: %s\n", s);

  test_dlopen();
  test();
  fprintf(stderr, "end main");
  exit(0);
  return 0;
  }





