/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */
/*
 *
 */

#include <bcm/bcm.h>

#ifndef __bcm_rename_h__
#define __bcm_rename_h__

#define malloc(x)     BCMMalloc(x, __FILE__, __LINE__)
#define free(x)       BCMFree(x, __FILE__, __LINE__)
#define realloc(x, y) BCMRealloc(x, y, __FILE__, __LINE__)
#define calloc(x, y)  BCMCalloc(x, y, __FILE__, __LINE__)

#endif
