/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */
/**********************************************************************
***********************************************************************/

#ifndef MEMCHECK

#include <stdio.h>
#include "memcheck.h"

// void __memcheck_init() __attribute__ ((constructor));
void __memcheck_init();
void __memcheck_close() __attribute__ ((destructor));

void __memcheck_init() {
  MemCheckInit();
  }

void __memcheck_close() {
  MemCheckClose();
  }
#endif

