/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */


#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#define DEBUGMAIN 1

#include "memcheck.h"

void test() {
  int y, i, bs=16; 
  void *alloc;

  alloc=(void*)malloc(1000);
  for (i=0; i<10; i++) {
    // init alloc
    memset(alloc, 0, 1000);
    alloc=(void*)realloc(alloc, 1000+i);
    }
  free(alloc);
  for (i=0; i<10; i++) {
    alloc=(void*)calloc(1000, 1);
    free(alloc);
    }
  }

int main(int argc, char **argv) {
  printf("main argc, argv %lx, %lx\n", (ulong)&argc, (ulong)argv);

  test();
  printf("main end\n");
  return 0;
  }

