/*
 * MemCheck, a memory-checker for C/C++.
 * 
 * This file is released under the terms of the GNU General Public License
 * as they appear in http://www.gnu.org/licenses/gpl.txt.
 * 
 * Copyright 2001, 2002 erwin.rieger@ibrieger.de
 */
/**********************************************************************
* File:    memchecks.c
* Projekt: Modul zur Speicherverwaltungs - Ueberwachung
* $Author: erwin $                                                   
* $Date: 2009/07/27 19:38:03 $
* $Log: memchecks.c,v $
* Revision 1.4  2009/07/27 19:38:03  erwin
* Save Work
*
* Revision 1.3  2001/05/30 10:54:23  erwin
* added debug stuff
*
* Revision 1.2  1999/03/04 12:19:33  tool
* Mit alloc - liste
*
* Revision 1.1  1999/02/27 14:26:03  tool
* geht gut, vor dlopen, mit mcstartup
*
***********************************************************************/

#ifndef MEMCHECK
#include <stdio.h>
#include "memcheck.h"

// void __memcheck_init() __attribute__ ((constructor));
void __memcheck_init();
void __memcheck_close() __attribute__ ((destructor));

void __memcheck_init() {
  MemCheckInit();
  }

void __memcheck_close() {
  MemCheckClose();
  }
#endif

